"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Dispatcher_1 = require("./Dispatcher");
const ViewResolver_1 = require("./resolver/ViewResolver");
const ControllerProcessor_1 = require("../decorator/processor/ControllerProcessor");
class Application {
    static initialize(configuration) {
        this.dispatcher = new Dispatcher_1.Dispatcher(configuration.port, ControllerProcessor_1.ControllerProcessor.process(configuration.controllers));
        ViewResolver_1.ViewResolver.initialize(configuration.templatesPath, configuration.viewsPath, configuration.templateEngine);
    }
    static run() {
        this.dispatcher.run();
    }
}
exports.Application = Application;
//# sourceMappingURL=Application.js.map