"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ResponseType_1 = require("../enum/ResponseType");
const ViewResolver_1 = require("./resolver/ViewResolver");
class Handler {
    constructor(requestUrl, requestMethod, action, responseType) {
        this._requestUrl = requestUrl;
        this._requestMethod = requestMethod;
        this._action = action;
        this._responseType = responseType;
    }
    handleResponse(response) {
        let handlerResult = Reflect.apply(this._action, this, []);
        switch (this._responseType) {
            case ResponseType_1.ResponseType.JSON: {
                response.setHeader("Content-Type", "application/json");
                response.write(JSON.stringify(handlerResult));
                break;
            }
            case ResponseType_1.ResponseType.VIEW: {
                response.setHeader("Content-Type", "text/html");
                response.write(ViewResolver_1.ViewResolver.getResolvedView(handlerResult));
            }
        }
    }
    get requestUrl() {
        return this._requestUrl;
    }
    set requestUrl(value) {
        this._requestUrl = value;
    }
    get requestMethod() {
        return this._requestMethod;
    }
    set requestMethod(value) {
        this._requestMethod = value;
    }
    get action() {
        return this._action;
    }
    set action(value) {
        this._action = value;
    }
    get responseType() {
        return this._responseType;
    }
    set responseType(value) {
        this._responseType = value;
    }
}
exports.Handler = Handler;
//# sourceMappingURL=Handler.js.map