"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TemplateEngine_1 = require("../../enum/TemplateEngine");
const util_1 = require("util");
class Configuration {
    constructor(port, controllers, templatesPath, viewsPath, templateEngine) {
        this._port = util_1.isNullOrUndefined(port) ? 80 : port;
        this._controllers = util_1.isNullOrUndefined(controllers) ? [] : controllers;
        this._templatesPath = util_1.isNullOrUndefined(templatesPath) ? "" : templatesPath;
        this._viewsPath = util_1.isNullOrUndefined(viewsPath) ? "" : viewsPath;
        this._templateEngine =
            util_1.isNullOrUndefined(templateEngine) ? TemplateEngine_1.TemplateEngine.NONE : templateEngine;
    }
    get port() {
        return this._port;
    }
    set port(value) {
        this._port = value;
    }
    get controllers() {
        return this._controllers;
    }
    set controllers(value) {
        this._controllers = value;
    }
    get templatesPath() {
        return this._templatesPath;
    }
    set templatesPath(value) {
        this._templatesPath = value;
    }
    get viewsPath() {
        return this._viewsPath;
    }
    set viewsPath(value) {
        this._viewsPath = value;
    }
    get templateEngine() {
        return this._templateEngine;
    }
    set templateEngine(value) {
        this._templateEngine = value;
    }
}
exports.Configuration = Configuration;
//# sourceMappingURL=Configuration.js.map