"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
require("reflect-metadata");
const Key_1 = require("../../constant/Key");
const Path = require("path");
function Controller(basePath) {
    basePath = util_1.isNullOrUndefined(basePath) ? "/" : basePath;
    return function (target) {
        let handlers = [];
        if (Reflect.hasMetadata(Key_1.Key.METADATA_CONTROLLER_HANDLERS, target.prototype)) {
            handlers = Reflect.getMetadata(Key_1.Key.METADATA_CONTROLLER_HANDLERS, target.prototype);
            for (let handler of handlers) {
                handler.requestUrl = Path.join(basePath, handler.requestUrl);
            }
        }
        Reflect.defineMetadata(Key_1.Key.METADATA_CONTROLLER_HANDLERS, handlers, target.prototype);
        Reflect.defineMetadata(Key_1.Key.METADATA_CONTROLLER_BASE_PATH, basePath, target.prototype);
    };
}
exports.Controller = Controller;
//# sourceMappingURL=Controller.js.map