"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Key_1 = require("../../constant/Key");
const ResponseType_1 = require("../../enum/ResponseType");
function JsonGenerator() {
    return function (target, propertyKey, propertyDescriptor) {
        let existingHandlers = [];
        if (Reflect.hasMetadata(Key_1.Key.METADATA_CONTROLLER_HANDLERS, target)) {
            existingHandlers = Reflect.getMetadata(Key_1.Key.METADATA_CONTROLLER_HANDLERS, target);
            for (let existingHandler of existingHandlers) {
                if (existingHandler.action === propertyDescriptor.value) {
                    existingHandler.responseType = ResponseType_1.ResponseType.JSON;
                    return;
                }
            }
        }
        let jsonGeneratorKeys = [];
        if (Reflect.hasMetadata(Key_1.Key.METADATA_CONTROLLER_JSON_GENERATOR_KEYS, target)) {
            jsonGeneratorKeys = Reflect.getMetadata(Key_1.Key.METADATA_CONTROLLER_JSON_GENERATOR_KEYS, target);
        }
        jsonGeneratorKeys.push(propertyKey);
        Reflect.defineMetadata(Key_1.Key.METADATA_CONTROLLER_JSON_GENERATOR_KEYS, jsonGeneratorKeys, target);
    };
}
exports.JsonGenerator = JsonGenerator;
//# sourceMappingURL=JsonGenerator.js.map