"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Key_1 = require("../../constant/Key");
const ResponseType_1 = require("../../enum/ResponseType");
function ViewGenerator() {
    return function (target, propertyKey, propertyDescriptor) {
        let existingHandlers = [];
        if (Reflect.hasMetadata(Key_1.Key.METADATA_CONTROLLER_HANDLERS, target)) {
            existingHandlers = Reflect.getMetadata(Key_1.Key.METADATA_CONTROLLER_HANDLERS, target);
            for (let existingHandler of existingHandlers) {
                if (existingHandler.action === propertyDescriptor.value) {
                    existingHandler.responseType = ResponseType_1.ResponseType.VIEW;
                    return;
                }
            }
        }
        let viewGeneratorKeys = [];
        if (Reflect.hasMetadata(Key_1.Key.METADATA_CONTROLLER_VIEW_GENERATOR_KEYS, target)) {
            viewGeneratorKeys = Reflect.getMetadata(Key_1.Key.METADATA_CONTROLLER_VIEW_GENERATOR_KEYS, target);
        }
        viewGeneratorKeys.push(propertyKey);
        Reflect.defineMetadata(Key_1.Key.METADATA_CONTROLLER_VIEW_GENERATOR_KEYS, viewGeneratorKeys, target);
    };
}
exports.ViewGenerator = ViewGenerator;
//# sourceMappingURL=ViewGenerator.js.map