import { Dispatcher } from "./Dispatcher";
import { ViewResolver } from "./resolver/ViewResolver";
import { ControllerProcessor } from "../decorator/processor/ControllerProcessor";
import { Configuration } from "./model/Configuration";

export class Application {

    private static dispatcher: Dispatcher;

    public static initialize( configuration: Configuration ) {

        this.dispatcher = new Dispatcher(
            configuration.port,
            ControllerProcessor.process( configuration.controllers )
        );

        ViewResolver.initialize(
            configuration.templatesPath,
            configuration.viewsPath,
            configuration.templateEngine
        );

    }

    public static run(): void {
        this.dispatcher.run();
    }

}

