import { TemplateEngine } from "../../enum/TemplateEngine";
import { isNullOrUndefined } from "util";

export class Configuration {

    private _port: number;
    private _controllers: ( new() => any )[];
    private _templatesPath: string;
    private _viewsPath: string;
    private _templateEngine: TemplateEngine;

    constructor(
        port?: number,
        controllers?: ( new() => any )[],
        templatesPath?: string,
        viewsPath?: string,
        templateEngine?: TemplateEngine ) {

        this._port = isNullOrUndefined( port ) ? 80 : port;
        this._controllers = isNullOrUndefined( controllers ) ? [] : controllers;
        this._templatesPath = isNullOrUndefined( templatesPath ) ? "" : templatesPath;
        this._viewsPath = isNullOrUndefined( viewsPath ) ? "" : viewsPath;
        this._templateEngine =
            isNullOrUndefined( templateEngine ) ? TemplateEngine.NONE : templateEngine;

    }

    get port(): number {
        return this._port;
    }

    set port( value: number ) {
        this._port = value;
    }

    get controllers(): ( new() => any )[] {
        return this._controllers;
    }

    set controllers( value: ( new() => any )[] ) {
        this._controllers = value;
    }

    get templatesPath(): string {
        return this._templatesPath;
    }

    set templatesPath( value: string ) {
        this._templatesPath = value;
    }

    get viewsPath(): string {
        return this._viewsPath;
    }

    set viewsPath( value: string ) {
        this._viewsPath = value;
    }

    get templateEngine(): TemplateEngine {
        return this._templateEngine;
    }

    set templateEngine( value: TemplateEngine ) {
        this._templateEngine = value;
    }

}