import { Key } from "../../constant/Key";
import { Handler } from "../../core/Handler";
import { ResponseType } from "../../enum/ResponseType";

export function JsonGenerator() {

    return function( target: any, propertyKey: string, propertyDescriptor: PropertyDescriptor ) {

        let existingHandlers: Handler[] = [];
        if( Reflect.hasMetadata( Key.METADATA_CONTROLLER_HANDLERS, target ) ) {

            existingHandlers = Reflect.getMetadata(
                Key.METADATA_CONTROLLER_HANDLERS,
                target
            );
            for( let existingHandler of existingHandlers ) {

                if( existingHandler.action === propertyDescriptor.value ) {
                    existingHandler.responseType = ResponseType.JSON;
                    return;
                }

            }

        }

        let jsonGeneratorKeys: string[] = [];
        if( Reflect.hasMetadata( Key.METADATA_CONTROLLER_JSON_GENERATOR_KEYS, target ) ) {
            jsonGeneratorKeys = Reflect.getMetadata(
                Key.METADATA_CONTROLLER_JSON_GENERATOR_KEYS,
                target
            );
        }
        jsonGeneratorKeys.push( propertyKey );
        Reflect.defineMetadata(
            Key.METADATA_CONTROLLER_JSON_GENERATOR_KEYS,
            jsonGeneratorKeys,
            target
        );

    }

}